#ifndef _LR_H_
#define _LR_H_

#pragma ident "@(#)lr.h	1.1 12/12/96 Voronoi"
// Dec 1996
// Copyright 1996 SFBellenot All rights reserved

#include "halfedge.h"
#include <string.h>

//template on HalfEdge?

class LR
{
public:
	LR ( int SqrtNumberOfSites, Real XMin, Real XMax )
	{
		hashSize = 2 * SqrtNumberOfSites;
		xMin = XMin;
		deltaX = XMax - XMin;
		ntry = 0;
		totalsearch = 0;

		hash = new HalfEdge* [hashSize];
		memset ( hash, 0, hashSize*sizeof(HalfEdge*) );
		LeftEnd = new HalfEdge ( NULL, 0 );
		RightEnd = new HalfEdge ( NULL, 0 );
		LeftEnd->LeftEndSet ( RightEnd );
		hash[0] = LeftEnd;
		hash[hashSize-1] = RightEnd;
	}
	~LR()
	{
		delete[] hash;
		delete LeftEnd;
		delete RightEnd;
	}
	HalfEdge* LeftBnd ( Point& p );
	HalfEdge* LeftMost () { return LeftEnd->RightHalfEdge(); }
	void Print ( Real y );
	
private:
	HalfEdge* AtBucket ( int b )
	{
		if ( (b < 0) || ( b >= hashSize ) )
			return NULL;
		HalfEdge* he = hash[b];
		if ( (he == NULL) || he->InLR() )
			return he;

		hash[b] = NULL;
		//cout << "LRRemoving at " << b << " he " << hex << he << endl;
		// he != NULL but it is not InLR
		he->Deref();
		return NULL;
	}
	int Bucket ( Point& p )
	{
		int bucket = (p.X() - xMin)/ deltaX * hashSize;
		if ( bucket < 0 )
			bucket = 0;
		if ( bucket >= hashSize )
			bucket = hashSize - 1;
		return bucket;
	}
	int hashSize;
	Real xMin;
	Real deltaX;
	HalfEdge** hash;
	HalfEdge* LeftEnd;
	HalfEdge* RightEnd;

	int ntry;
	int totalsearch;
};

#endif
