static char SccsId[] = "@(#)main.cc	1.1 12/12/96 Graphics";
// Dec 1996
// Copyright 1996 SFBellenot All rights reserved
// Main.cc
// Sample TK main

#include <tk.h>
#include <iostream.h>
#include <strstream.h>
#include <string.h>
#include "pad.h"

Pad * padPtr;
// so the application can add more commands
Tcl_Interp* tclInterp;

// The Links needed
int AppOptions ( int argc, char ** argv );
int AppInit ();
int AppRestart ();
int AppLoop ();
int AppCleanup ();
// Options returns the index of the option of -- or 
// should use getopt and return optind - 1
// One time only initialization returns 0 on success
// One time only cleanup returns 0 on success
// Main Loop returns 0 when done.

int PadCmd ( ClientData clientData, Tcl_Interp * interp,
	int argc, char ** argv );

int LoopStep ( ClientData clientData, Tcl_Interp * interp,
	int argc, char ** argv );

int Restart ( ClientData clientData, Tcl_Interp * interp,
	int argc, char ** argv );

// we will like code to backup or jump forward, but not in
// every application

int Debug ( ClientData clientData, Tcl_Interp * interp,
	int argc, char ** argv );

int Pad2Pointer ( ClientData clientData, Tcl_Interp * interp,
	int argc, char ** argv );

int Tcl_AppInit ( Tcl_Interp * interp );

int main ( int argc, char **argv )
{
	int i = AppOptions(argc, argv);
	Tk_Main ( argc - i, &argv[i], Tcl_AppInit );
	return 0;
}

extern char TclSrc[];

int Tcl_AppInit ( Tcl_Interp * interp )
{
	if ( Tcl_Init ( interp ) == TCL_ERROR )
		return TCL_ERROR;
	if ( Tk_Init ( interp ) == TCL_ERROR )
		return TCL_ERROR;

	tclInterp = interp;

	Tcl_CreateCommand ( interp, "pad", PadCmd,
		(ClientData) Tk_MainWindow ( interp ),
		(Tcl_CmdDeleteProc *) NULL );

	Tcl_CreateCommand ( interp, "loopStep", LoopStep,
		(ClientData) Tk_MainWindow ( interp ),
		(Tcl_CmdDeleteProc *) NULL );

	Tcl_CreateCommand ( interp, "reread", Restart,
		(ClientData) Tk_MainWindow ( interp ),
		(Tcl_CmdDeleteProc *) NULL );

	Tcl_CreateCommand ( interp, "path2pointer", Pad2Pointer,
		(ClientData) Tk_MainWindow ( interp ),
		(Tcl_CmdDeleteProc *) NULL );

	Tcl_CreateCommand ( interp, "doDebug", Debug,
		(ClientData) Tk_MainWindow ( interp ),
		(Tcl_CmdDeleteProc *) NULL );

	Tcl_Eval(interp, TclSrc );

	AppInit();
	return TCL_OK;
}

int LoopStep ( ClientData clientData, Tcl_Interp * interp,
	int argc, char ** argv )
{
	if ( ! AppLoop() )
	{
		AppCleanup();
		PadFlush ( padPtr );
		#if SFB
		Tcl_Eval(interp, "doStop");
		//Tcl_Eval(interp, "after idle {destroy .}" );
		#else
		Tcl_Eval(interp, "doStop");
		Tcl_Eval(interp, "update idletasks");
		Tcl_Eval(interp, "after 5000 {destroy .}" );
		#endif
	}

	PadFlush ( padPtr );
	return TCL_OK;
}

int Restart ( ClientData clientData, Tcl_Interp * interp,
	int argc, char ** argv )
{
	if ( AppRestart() )
		return TCL_ERROR;
	return TCL_OK;
}

int Debug ( ClientData clientData, Tcl_Interp * interp,
	int argc, char ** argv )
{
	char line[1000];

	cout << "debug% ";
	cout << flush;
	while ( gets(line) )
	{
		if ( strcmp (line, "quit" ) == 0 )
			break;
		Tcl_Eval(interp, line);
		cout << interp->result << endl;
		cout << "debug% ";
		cout << flush;
	}
	return TCL_OK;
}


// This translates its paramater ".pad" in this case
// to the global padPtr.

int Pad2Pointer ( ClientData clientData, Tcl_Interp * interp,
	int argc, char ** argv )
{
	if ( argc != 2 )
	{
		Tcl_AppendResult(interp, "wrong # args:  should be \"",
			    argv[0], " pathName \"", (char *) NULL);
		return TCL_ERROR;
	}

	Tcl_CmdInfo Cmd;

	if ( Tcl_GetCommandInfo ( interp, argv[1], &Cmd ) == 1 )
	{
		padPtr = (Pad *) Cmd.clientData;
	}
	return TCL_OK;
}

