# Now sourced in the main.cc file
# Embedded into the c++ code with tcl2c
#
# SccsId = "@(#)main.tcl	1.1 12/12/96 Voronoi";
# 
#
proc doStart { } {
	global run
	set run true
}

proc doStop { } {
	global run
	set run false
}

# this silents tclsh for a while
set tcl_prompt1 { }

proc setup { } {
	global c
	set t .
	wm title $t "Main3"
	wm iconname $t "graph"

	set w ""
	label $w.msg -justify left -text "Fortune's Voronoi Sweep Algorithm/Code"
	pack $w.msg -side top

	frame $w.frame
	pack $w.frame -side top -fill both -expand yes

	pad  $w.pad -background black -width 400 -height 400
	pack $w.pad -side top -expand yes -fill both -pady 2m

	frame $w.buttons
	pack  $w.buttons -side bottom -expand y -fill x -pady 2m
	button $w.buttons.quit -text Quit -command "destroy $t"
	# steal the stuff from vtk here
	button $w.buttons.debug -text Debug -command "wm deiconify .dbInteract"
	button $w.buttons.restart -text Restart -command "reread"
	button $w.buttons.start -text "Start" -command "doStart"
	button $w.buttons.stop -text "Stop" -command "doStop"
	button $w.buttons.step -text "Step" -command "loopStep"

	pack $w.buttons.quit $w.buttons.debug $w.buttons.restart \
		$w.buttons.start \
		$w.buttons.stop $w.buttons.step \
		-side left -expand 1 

	bind $t <KeyPress-q> "destroy $t"

	tkwait visibility $t
	update idletasks

	# stores the pointer is the C++ global variable padPtr
	path2pointer $w.pad
}

set logCount 1

proc mainloop { } {
	global run c logCount

	if { $run == "true" } {
		loopStep
		incr logCount
		update idletasks
		after idle mainloop
	} else {
		after 1000 mainloop
	}
}

# a generic interactor for tcl stolen from vtk
#
set dbInteractBold "-background #43ce80 -relief raised -borderwidth 1"
set dbInteractNormal "-background #c0c0c0 -relief flat"
set dbInteractTagcount 1;

proc dbInteract {} {

    proc dodb {s w} {
	global dbInteractBold dbInteractNormal dbInteractTagcount;
	set tag [append tagnum $dbInteractTagcount];
	incr dbInteractTagcount 1;
	.dbInteract.text configure -state normal
	.dbInteract.text insert end $s $tag
	eval .dbInteract.text tag configure $tag $dbInteractNormal
	.dbInteract.text tag bind $tag <Any-Enter> \
	    ".dbInteract.text tag configure $tag $dbInteractBold"
	.dbInteract.text tag bind $tag <Any-Leave> \
	    ".dbInteract.text tag configure $tag $dbInteractNormal"
	.dbInteract.text tag bind $tag <1> "dodb [list $s] .dbInteract";
	.dbInteract.text insert end \n; 
	.dbInteract.text insert end [uplevel 1 $s]; 
	.dbInteract.text insert end \n\n; 
	.dbInteract.text configure -state disabled
	.dbInteract.text yview end
    }

    catch {destroy .dbInteract}
    toplevel .dbInteract
    wm title .dbInteract "debug Interactor"
    wm iconname .dbInteract "debug"
    
    frame .dbInteract.buttons
    pack  .dbInteract.buttons -side bottom -fill x -pady 2m
    button .dbInteract.buttons.dismiss -text Dismiss \
	-command "wm withdraw .dbInteract"
    pack .dbInteract.buttons.dismiss -side left -expand 1
    
    frame .dbInteract.file
    label .dbInteract.file.label -text "Command:" -width 10 -anchor w
    entry .dbInteract.file.entry -width 40 
    bind .dbInteract.file.entry <Return> {
	dodb [%W get] .dbInteract; %W delete 0 end}
    pack .dbInteract.file.label -side left
    pack .dbInteract.file.entry -side left -expand 1 -fill x
    
    text .dbInteract.text -yscrollcommand ".dbInteract.scroll set" \
	-setgrid true -width 60 -height 8 -wrap word
    scrollbar .dbInteract.scroll -command ".dbInteract.text yview"
    pack .dbInteract.scroll -side right -fill y
    pack .dbInteract.text -side bottom -expand 1 -fill both
    pack .dbInteract.file -pady 3m -padx 2m -side bottom -fill x 
    
    .dbInteract.text configure -state disabled
    wm withdraw .dbInteract
}

dbInteract;

### start of tk main ###
set run true
setup
after idle mainloop
