static char SccsId[] = "@(#)pq.cc	1.1 12/12/96 Voronoi";
// pq.cc
// Dec 1996
// Copyright 1996 SFBellenot All rights reserved

#include "pq.h"

void PQ::Insert ( HalfEdge* he, Vertex* v, Real offset)
{
	PQnode* last;
	PQnode* next;

	he->SetVertex ( v, offset );

	//cout << "PQ::Insert " << he->YStar() << endl;
	last = hash[Bucket(he)];
	if ( last == NULL )
	{
		PQnode* me = new PQnode;
		me->he = he;
		me->next = NULL;
		he->Ref();
		hash[Bucket(he)] = me;
	}
	else if ( he->Less ( last->he ) )
	{
		PQnode* me = new PQnode;
		me->he = he;
		me->next = last;
		he->Ref();
		hash[Bucket(he)] = me;
	}
	else
	{
		while ( (next = last->next) != (PQnode *) NULL
			&& next->he->Less ( he ) )
		{
			last = next;
		}
		PQnode* me = new PQnode;
		me->he = he;
		he->Ref();
		me->next = last->next;
		last->next = me;
	}
	count += 1;
}

void PQ::Delete ( HalfEdge* he )
{
	PQnode* last;

	last = hash[Bucket(he)];
	if ( last == NULL )
		return;
	
	if ( last->he == he )
	{
		hash[Bucket(he)] = last->next;
		count -= 1;
		he->Deref();
		//cout << "PQ::Delete " << he->YStar() << " " << hex << he << endl;
		delete last;
	}
	else
	{
		while (last->next && last->next->he != he)
			last = last->next;
		if ( last->next )
		{
			PQnode* temp = last->next;
			last->next = temp->next;
			count -= 1;
			he->Deref();
			//cout << "PQ::Delete " << he->YStar() << " " << hex << he << endl;
			delete temp;
		}
	}
}

Point PQ::MinPoint()
{
	while (hash[min] == NULL)
	{
		min += 1;
	}
	return hash[min]->he->VertexStar();
}

HalfEdge* PQ::ExtractMin()
{
	PQnode* curr;
	HalfEdge* he;

	curr = hash[min];
	hash[min] = curr->next;
	count -= 1;
	he = curr->he;
	delete curr;
	//cout << "PQExtract y* " <<  he->YStar() << " " << hex << he << endl;
	return he;
}

void PQ::Print()
{
	int i = min;
	PQnode* curr;

	for ( ; i < hashSize; i++ )
	{
		curr = hash[i];
		while ( curr )
		{
			cout << i << " " << hex << curr->he << " y* " << dec
				<< curr->he->YStar() << endl;
			curr = curr->next;
		}
	}
	cout << "PQ::Print ends" << endl;
}
