static char SccsId[] = "@(#)sitelist.cc	1.1 12/12/96 Voronoi";
// sitelist.cc
// Dec 1996
// Copyright 1996 SFBellenot All rights reserved

#include "sitelist.h"
#include <string.h>
#include <iostream.h>
#include <stdlib.h>

static int scomp ( void* t1, void* t2 )
{
	Point* s1 = (Point *) t1;
	Point* s2 = (Point *) t2;

	if (s1->Y() < s2->Y())
		return (-1);
	if (s1->Y() > s2->Y())
		return (1);
	if (s1->X() < s2->X())
		return (-1);
	if (s1->X() > s2->X())
		return (1);
	return (0);
}


SiteList::SiteList( int Sorted )
{
	Real x;
	Real y;

	nSites = 0;
	pSite = 0;
	if ( Sorted )
	{
		fromFile = TRUE;
	}
	else
	{
		fromFile = FALSE;
		S = new Site[4000];
		while ( TRUE )
		{
			if ( nSites % 4000 == 0 )
			{
				Site* tmp = S;
				S = new Site[nSites+4000];
				memmove ( S, tmp, nSites * sizeof (Site) );
				delete[] tmp;
			}
			cin >> x;
			cin >> y;
			if ( cin )
			{
				S[nSites] = Site(x,y);
				nSites++;
			}
			else break;
		}
		qsort ( S, nSites, sizeof (Site), scomp );
		xmin = S[0].X();
		xmax = xmin;
		ymin = S[0].Y();
		ymax = S[nSites-1].Y();
		for ( int i = 1; i < nSites; i++ )
		{
			xmin = min ( xmin, S[i].X() );
			xmax = max ( xmax, S[i].X() );
		}
	}
}

Site* SiteList::NextSite()
{
	Site* answer = NULL;
	Real x;
	Real y;

	if ( fromFile )
	{
		pSite++;
		cin >> x;
		cin >> y;
		if ( cin )
			answer = new Site ( x, y );
	}
	else
	{
		if ( pSite < nSites )
		{
			answer = &S[pSite];
			pSite++;
		}
	}
	return answer;
}
