#ifndef _VORONOI_H_
#define _VORONOI_H_

#pragma ident "@(#)voronoi.h	1.1 12/12/96 Voronoi"
// Dec 1996
// Copyright 1996 SFBellenot All rights reserved

#include "lr.h"
#include "pq.h"
#include "sitelist.h"

class Pad;

class Voronoi
{
public:
	Voronoi( Real XMin, Real XMax, Real YMin, Real YMax, SiteList* SList,
		int SqrtNumberOfSites );
	~Voronoi();
	int Loop();
	void Draw ( Pad* p );
	void Line ( Real x1, Real y1, Real x2, Real y2 );
	void Circle ( Point& p );
	void End();
	Real PXMin() { return pxMin; }
	Real PXMax() { return pxMax; }
	Real PYMin() { return pyMin; }
	Real PYMax() { return pyMax; }
	SiteList* SL() { return sl; }
	void Triangle () { triangle = TRUE; }

private:
	Real xMin;
	Real xMax;
	Real yMin;
	Real yMax;
	Real pxMin;
	Real pxMax;
	Real pyMin;
	Real pyMax;
	Real scale;
	Real cradius;
	Real ySweep;
	int triangle;
	Pad* pad;
	Site* bottomSite;
	Site* newSite;
	SiteList* sl;
	PQ* pq;
	LR* lr;
	HalfEdge* complete;	
};

#endif
